/* 
 * File:   CNFmanager.h
 * Author: Stanislav Pelák
 */

#ifndef CNFMANAGER_H
#define	CNFMANAGER_H

#include <vector>
#include <string>
#include <sstream>
#include <map>
#include <list>

#include "Circuit.h"
using namespace std;

class CNFmanager {
public:
    static string replaceVariables(string mask, map<string, int>* dictionary);
    template <class T> static vector<string> GetMapKeys(map<string, T>* m);
    static string concatClausules(vector<string>* keys, map<string, string>* cnf);
    static string xorMergeToDIMACS(Circuit* first, Circuit* second);
    virtual ~CNFmanager() {}
    
private:
    CNFmanager(){}
    CNFmanager(const CNFmanager& orig) {}
    static string joinWithOR(vector<int> gates, int ORindex);
    static int countOccurences(string str, string value);
};

#endif	/* CNFMANAGER_H */

