/* 
 * File:   Configuration.cpp
 * Author: Stanislav Pelák
 */

#include <iostream>
#include <map>
#include <set>
#include <vector>
#include <ctime>
#include "Configuration.h"
#include "Randomizer.h"
#include "Circuit.h"
using namespace std;

long Configuration::GENERATED_CIRCUITS_COUNTER = 0;
long Configuration::MAX_GENERATED_CIRCUITS = 0;
void Configuration::nextCircuit() {
    Configuration::GENERATED_CIRCUITS_COUNTER++;
    if((Configuration::MAX_GENERATED_CIRCUITS > 0) && (Configuration::GENERATED_CIRCUITS_COUNTER >= Configuration::MAX_GENERATED_CIRCUITS)) {
        cout << "Maximum generated circuits limit reached" << endl;
        exit(0);
    }
}

string Configuration::NAME_PREFIX = "g";
bool Configuration::EQUIV_CHILDREN = false;
bool Configuration::GENERATE_GENOTYPE_RANDOMLY = true;

//Circuit
int Configuration::SMALLEST_PHENOTYPE = 0;
int Configuration::MAX_FITNESS = 0;
int Configuration::GENES_LENGTH = 0;            //all genes (incl. inputs)

//Window
int Configuration::LAST_WINDOW_POSITION = 0;
int Configuration::MIN_WINDOW_POSITION = 0;

int Configuration::WINDOW_SIZE = 0;
int Configuration::WINDOW_SIZE_INCREMENT = 0;

//Coeficient
int Configuration::LAST_COEFICIENT_VALUE = -1;
int Configuration::MAXIMUM_COEFICIENT_REPEAT = 0;
int Configuration::COEFICIENT_REPEAT_COUNTER = 0;

bool Configuration::RANDOM_INDIVIDUALS = false;
