/* 
 * File:   Configuration.h
 * Author: Stanislav Pelák
 */

#ifndef CONFIGURATION_H
#define	CONFIGURATION_H

#include "Circuit.h"
#include <string>


class Configuration {
public:
    
    static std::string NAME_PREFIX;
    static bool EQUIV_CHILDREN;
    static bool GENERATE_GENOTYPE_RANDOMLY;
    
    static int SMALLEST_PHENOTYPE;
    static int MAX_FITNESS;
    static int GENES_LENGTH;
    
    static int LAST_WINDOW_POSITION;
    static int MIN_WINDOW_POSITION;
    
    static int WINDOW_SIZE;
    static int WINDOW_SIZE_INCREMENT;
    
    static int LAST_COEFICIENT_VALUE;
    static int MAXIMUM_COEFICIENT_REPEAT;
    static int COEFICIENT_REPEAT_COUNTER;
    
    static long GENERATED_CIRCUITS_COUNTER;
    static long MAX_GENERATED_CIRCUITS;
    static void nextCircuit();
    
    static bool RANDOM_INDIVIDUALS;
    
private:
    Configuration();
    Configuration(const Configuration& orig);
    virtual ~Configuration();
};

#endif	/* CONFIGURATION_H */

