/* 
 * File:   GateMapper.h
 * Author: Stanislav Pelák
 */

#ifndef GATEMAPPER_H
#define	GATEMAPPER_H

#include <string>
#include <map>
#include "Gate.h"
#include <iostream>
using namespace std;

class GateMapper {
public:
    static GateMapper* getInstance() ;
    
    int getCode(string name) const;
    Gate* getGate(int code) const;
    Gate* getGate(string name) const;
    Gate* getRandomGate() const;
    int getRandomGateCode() const;
    virtual ~GateMapper();
    
private:
    GateMapper();
    GateMapper(const GateMapper& orig){}
    static GateMapper* instance;
    static map<int, Gate*> gates;
    static map<int, Gate*> fillMap();
    static GateMapper* create();
};

#endif	/* GATEMAPPER_H */

