/* 
 * File:   Generation.h
 * Author: Stanislav Pelák
 */

#ifndef GENERATION_H
#define	GENERATION_H

#include "MutableCircuit.h"


class Generation {
public:

    Generation(Circuit* referenceCircuit, int r, int c, int l, int pos, int lambda, int mut_rate, int in, int out);
    Generation(Circuit* referenceCircuit, int r, int c, int l, int lambda, int mut_rate, int in, int out);
    Generation(Circuit* referenceCircuit, MutableCircuit* individual, map<string, int> params, int id);
    virtual ~Generation();
    
    Generation* evolve(bool print);
    
    static int getMaxFitness() { return maxFitness; }
    static MutableCircuit* getBestCircuit() { return bestCircuit; }
    int getGenerationID() const { return generationID; }
    
    static void reset() {
        delete Generation::bestCircuit;
        Generation::bestCircuit = NULL;
    }
    
private:
    
    int generationID;
    Circuit* referenceCircuit;
    static int maxFitness;
    static MutableCircuit* bestCircuit;
    static string prevParent;
    vector<MutableCircuit*> population;
    map<string, int> params;
    
    Generation(const Generation& orig){cout << "Generation copy constructor, id=" << orig.generationID << endl;}
    
    static MutableCircuit* pickRandom(vector<MutableCircuit*>* source);
};

#endif	/* GENERATION_H */

