//---------------------------------------------------------------------------
#include "stdafx.h"

#ifdef _MSC_VER
#pragma hdrstop
#endif

using namespace std;

#include "myExcept.h"
#include "bitvector.h"
#include "Cube.h"
#include "WTerm.h"

//---------------------------------------------------------------------------

WTerm::WTerm(void):
	Cube()
{
}

WTerm::WTerm( unsigned int iv, unsigned int ov ):
	Cube(iv)
{
	W.assign(ov, 0);
}

WTerm::~WTerm(void)
{
}

void WTerm::setWeights( const string s )
{
	unsigned int i;

	W.clear();
	for ( i = 0; i < s.length(); i++ )
		if ( s[i] == '-' ) W.push_back( -1 );
		else if ( s[i] >= '0' && s[i] <= '9' ) W.push_back( s[i] - '0' );
		else throw RuntimeException( "WTerm::setWeights: Bad weight value" );
}

int WTerm::getWeight( const unsigned int out ) const
{
	if ( out >= W.size() ) throw RuntimeException( "WTerm::getWeight: Bad index" );
	return W[out];
}
