/* 
 * File:   OutputManager.cpp
 * Author: Stanislav Pelák
 */

#include "OutputManager.h"
#include "Configuration.h"

int OutputManager::cnt = 0;
string OutputManager::path = "";

void OutputManager::init(string path) {
    OutputManager::cnt = 0;
    OutputManager::path = path;
}

void OutputManager::printCircuitToBlif(Circuit* circuit, int fitness, string /*generation*/totalGenes, vector<string> refOutputKeys) {
    Blif* blif = circuit->toBlif(refOutputKeys);
    blif->SetModel(circuit->getModel());
    ostringstream s;
    s.str("");
    s << OutputManager::path << "_fit" << fitness;
    if(totalGenes.length() > 0)
        s << "_gen" << totalGenes;
    s << "_cnt_" << Configuration::GENERATED_CIRCUITS_COUNTER << ".blif";
    string filename(s.str());
    blif->SaveBlif(filename.c_str());
    delete blif;
}
