/* 
 * File:   SATsolverAdapter.h
 * Author: Stanislav Pelák
 */

#ifndef SATSOLVERADAPTER_H
#define	SATSOLVERADAPTER_H

#include <string>
#include "zchaff/SAT.h"
#include <iostream>
using namespace std;

class SATsolverAdapter {
public:
    static bool solve(string dimacs);
private:
    SATsolverAdapter(){cout << "SATsolverAdapter constructor" << endl;}
    SATsolverAdapter(const SATsolverAdapter& orig){cout << "SATsolverAdapter copy constructor" << endl;}
    virtual ~SATsolverAdapter(){cout << "SATsolverAdapter destructor" << endl;}
    
    static void read_cnf(SAT_Manager mng, string dimacs);
    static int verify_solution(SAT_Manager mng);
    static void handle_result(SAT_Manager mng, int outcome);
};

#endif	/* SATSOLVERADAPTER_H */

